// to printout the returned xml in text:  alert(velingoObjXMLHttp.responseText.substring(5000));

// global variables
var velingoXmlFile;
var updateFileGapMillis = 3600000;  //1 hour
var velingoObjXMLHttpForFile;
var velingoLicense = '5dc17d2f4e72eda51f68:3';

var velingo_host_server;
var velingoServiceURL;
var velingoHintURL;
var getFileServiceURL;
var getAdsIframeURL;
var velngoImageURL;
var poweredByImageURL;
var myVarsFilePath;
var vars_xml_version;
var velingoEmbedStylesFilePath;
var velingoEmbededStylesStr;

// buzz cloud
var tags_per_cloud;

// hints
var isShowHintsBuzzCloud;
var velingoHintLeft;
var velingoHintTop;
var hintImagesDir;
var velingo_h_hideHint;
var velingo_overHint;
var velingo_objSL;
var velingo_hintTarget;
var velingo_showDelayFlag;
var velingo_response;
var velingo_overTag=false;
// Delays
var VELINGO_HIDE_HINT_DELAY = 600; // Time before the hiding even begins and the actual hiding
var VELINGO_SHOW_HINT_DELAY = 300; // Time before the showing even begins and the actual showing
var VELINGO_SHOW_DELAY_CHECK_INTERVAL = 100; // Time between checking of the velingo_showDelayFlag
var DELAY_HIDING_BY_BODY = 200; // Hiding the hint by moving over the BODY is delayed by setting this timeout 

	
// history tracking
var velngoHistoryFilePath;
var velngoHistoryFile;
var velngoHistoryRecordsLimit;
var velingoCharset = "UTF-8";
const velingoId = "searchtags@velingo";

var ext;
const history_record_seperator = "  VELINGO_SEPERATOR  ";

var linksArray = new Array();;
var linksList;
var velingoQuery;
var velingoPageTitle;
var velingoObjXMLHttp;
var velingoPrevLink = "";

var variablesData;
var velingoXmlDoc;
var VelingoSearchEngineName;
var getQueryBox;
var getQueryCommand;
var resultElementTagName;
var isLinkResultCheckCommand;
var getLinkCommand;
var getInsertBeforeDivCommand;
var getAppendDocRelevancyNodeCommand;
var getAppendDocInfoNodeCommand;
var getAppendRegSponsoredTagsNodeCommand;
var getAppendSideSponsoredTagsNodeCommand;
var velingoTitleStyle;
var velingoTagStyle;
var velingoDefaultFontSize;
var velingoBuzzcloudStyle;
var velingoBuzzcloudTableStyle;

var appendDocInfoNodeArray;
var appendDocRelevancyNodeArray;

var velingoPrefs;

//sponsored links vars
var isLinkSponsoredRegCheckCommand;
var sponsoredRegArray;
var isLinkSponsoredSideCheckCommand;
var sponsoredSideArray;
var isDisplaySponsoredLinksTags;
var getSponsoredRegLinkCommand;
var getSponsoredSideLinkCommand;
var sponsoredTagsSmallNum = 3; // number of tags for sponsored on the right (small area)
// velingo sponsored links
var isDisplayVelingoSponsoredLinks;
var neverShowVelingoSponsElement;

var velingoSeperator = "&nbsp;&nbsp;|&nbsp;&nbsp;";
var side_spons_seperator = "<TD style='" + velingoDefaultFontSize + "'>|</TD>";

//velingo sponsored links - MIVA
var velingoLocalip = null;
var velingoSponsoredServiceUrl;
var velingoObjXMLHttpAd;
var velingoSponsoredAdsStr;

// tags language support
var velingoLanguagePrefs;
var LANGUAGE_ATTR_PREFIX = "&language=";
var isDisplayWestEuropeanTags;
var isDisplayOtherTags;

var velingotags = {

  // preferences window to open when user presses the menu item
  onMenuItemCommand: function() {
  	window.open("chrome://TagSense/content/menu.xul", null, "chrome,centerscreen,dependent");
  },
  
  // Register to receive notifications of preference changes
  registerPrefListener: function()
  {  
  	velingoPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("TagSense.");
  	velingoPrefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
  	velingoPrefs.addObserver("", this, false);
  },
  // Called when events occur on the preferences
  observe: function(subject, topic, data)
  {
	if (topic != "nsPref:changed")
	{
		return;
	}
	
	switch(data)
	{		
		case "tags_per_cloud":		
			tags_per_cloud = velingoPrefs.getIntPref("tags_per_cloud");
			break;		
		case "show_sponsored_links_tags":
			isDisplaySponsoredLinksTags = velingoPrefs.getBoolPref("show_sponsored_links_tags");
			break;
		case "num_of_history_records":
			velngoHistoryRecordsLimit = velingoPrefs.getIntPref("num_of_history_records");
			break;
		case "show_velingo_sponsored_links":		
			isDisplayVelingoSponsoredLinks = velingoPrefs.getBoolPref("show_velingo_sponsored_links");
			break;
		case "lang_western_european":		
			isDisplayWestEuropeanTags = velingoPrefs.getBoolPref("lang_western_european");
			break;
		case "lang_other":		
			isDisplayOtherTags = velingoPrefs.getBoolPref("lang_other");
			break;
		case "show_hints_buzzcloud":
			isShowHintsBuzzCloud = velingoPrefs.getBoolPref("show_hints_buzzcloud");
			break;
	}
  },
  
  
  // change in page / move between tabs
  onChange: function() { // collect links and get tags
 	var doc = getDocument();
	velingoPageTitle = doc.title;
	var isVTSOnPage = doc.getElementById("dummyVTS");
	if (velingoPageTitle != "")
	{
		// check whether we need to request an update for the vars.xml file, and do so
		requestXmlFile();

		// populate current engine's (if any) variables
		getEngineVariables(velingoPageTitle);

		// check if we are in a search results page & if it is configured to display tags		
		if (getQueryCommand != null && velingoPrefs.getBoolPref(VelingoSearchEngineName))
		{
			velingoQuery = eval(getQueryCommand);
			
			if (isVTSOnPage == null) 
			{				
				// get velingo sponsored links
				if (isDisplayVelingoSponsoredLinks)
				{					
					retrieveAds();
				}
				// get a list of the links on this page
				findLinks(doc,velingoQuery);
				// embed a mark on the page to let us know we already asked to retrieve tags
				var dummyDiv = doc.createElement("div");
				dummyDiv.setAttribute("id", "dummyVTS");
				var insertDiv = eval(getInsertBeforeDivCommand);
				// avoid Error: insertDiv has no properties
				if (insertDiv) {
					insertDiv.parentNode.insertBefore(dummyDiv, insertDiv);				
				
					// get and display all vts info
					getVtsInfo(); 
					velingoPrevLink = "";

					// write search to history file
					writeHistory(velingoQuery);
				}
			}
		}
	}
  },
  
  // load page
  onLoad: function() { 
  	velingotags.onChange();
  	var doc = getDocument();
  	// a possible result hit
	if ((velingoPageTitle != "") && (getQueryCommand == null) && (linksArray.length > 0))
	{ 
		// if the new page is a link that was in the results, save this hit
		// works when the hit is opened in same / new tab, not in new window
		var ind;
		var ind2;
		var currentLink = "" + doc.location;
		currentLink = currentLink.toLowerCase();
		var tempLink;
		var isHit = false;
		// check we are not filing 2 clicks on the same document one after another (usually happens when there are few frames on the document)
		if (velingoPrevLink != currentLink)
		{
			for (ind in linksArray)
			{
				tempLink = linksArray[ind];
				if ((tempLink == currentLink) || (("http://"+tempLink) == currentLink) || (("http://"+tempLink+"/") == currentLink) || (("http://www."+tempLink+"/") == currentLink))
				{
					// fire a result_hit event
					clickResult (currentLink ,velingoQuery);
					velingoPrevLink = currentLink;
					isHit = true;
					break;
				}
			}
			if (!isHit && sponsoredRegArray.length > 0)
			{
				for (ind2 in sponsoredRegArray) // possible hit on regular sponsored link					
				{
					tempLink = sponsoredRegArray[ind2];
					if (currentLink.indexOf(trim(tempLink)) > -1) // link value ends with a space (' ')
					{
						clickResult (tempLink ,velingoQuery);
						velingoPrevLink = currentLink;
						isHit = true;
						break;
					}
				}

			}
			if (!isHit && sponsoredSideArray.length > 0)
			{
				for (ind2 in sponsoredSideArray) // possible hit on side sponsored link					
				{
					tempLink = sponsoredSideArray[ind2];
					if (currentLink.indexOf(trim(tempLink)) > -1) // link value ends with a space (' ')
					{
						clickResult (tempLink ,velingoQuery);
						velingoPrevLink = currentLink;
						isHit = true;
						break;
					}
				}

			}
		}
	}
  }
};


//traverse links in page.  find result links.
function findLinks(doc, velingoQuery)
{
        var linkPaths = doc.getElementsByTagName(resultElementTagName);
        var numOfPaths = linkPaths.length;
        var linkPath;
        var index=0;
        var link;
        linksArray = new Array();
        sponsoredRegArray = new Array();
        sponsoredSideArray = new Array();
        appendDocInfoNodeArray = new Array();
        appendDocRelevancyNodeArray = new Array();
        linksList = "";
	for (var i = 0 ; i < numOfPaths ; i++)
	{		
		linkPath =  linkPaths[i];
		
		// check if this is a valid result link
		if (eval(isLinkResultCheckCommand))
		{	
			// get url
			link = eval(getLinkCommand);
			linksList += "&url=" + escape(link);
			linksArray[index] = link;
			// mark place to insert document tags if available
			appendDocInfoNodeArray[index] = eval(getAppendDocInfoNodeCommand);
			// mark place to insert document relevancy info
			appendDocRelevancyNodeArray[index] = eval(getAppendDocRelevancyNodeCommand);
			index++;
		}		
		else if (isDisplaySponsoredLinksTags) // sponsored links tags
		{			
			if (eval(isLinkSponsoredRegCheckCommand)) // top or buttom of page 
			{
				// get url
				link = eval(getSponsoredRegLinkCommand);
				linksList += "&url=" + link;
				linksArray[index] = link;			
				sponsoredRegArray[index] = link; //later use for recognizing hit events
				// mark place to insert document tags if available
				appendDocInfoNodeArray[index] = eval(getAppendRegSponsoredTagsNodeCommand);				
				index++;
			}			
			else if (eval(isLinkSponsoredSideCheckCommand)) // side of page
			{
				// get url
				link = eval(getSponsoredSideLinkCommand);
				linksList += "&url=" + link;
				linksArray[index] = link;			
				sponsoredSideArray[index] = link; //later use for recognizing hit events
				// mark place to insert document tags if available
				appendDocInfoNodeArray[index] = eval(getAppendSideSponsoredTagsNodeCommand);
				index++;		
			}
		}
	}
	return linksArray;
}

// sends an event to MIVA to get velingo sponsored ads
function retrieveAds()
{
	velingoSponsoredAdsStr = "";
	velingoObjXMLHttpAd = new XMLHttpRequest();
	velingoObjXMLHttpAd.onreadystatechange = buildAdsStr;
	var requestBody = "?getresults&base=0&dc=4&aff_id=57092&fl=0&fmt=xml8859-2&at=MBOOEPB8J&mt=" + velingoQuery + "&ip_addr=" + velingoLocalip; //MIVA
	//var requestBody = "?Service=AWSECommerceService&AWSAccessKeyId=1QCY98SSDTDVMWP03V82&Operation=ItemSearch&SearchIndex=Books&Keywords=" + encodeURI(velingoQuery) + ")"; //AMAZON
	velingoObjXMLHttpAd.open("GET", velingoSponsoredServiceUrl + requestBody, true);	
	velingoObjXMLHttpAd.send(null);
}

// Build a string representation of the ads to display on page
function buildAdsStr()
{
	if ((velingoObjXMLHttpAd.readyState==4 || velingoObjXMLHttpAd.readyState=="complete") && velingoObjXMLHttpAd.status==200)
	{
		var responseXml = velingoObjXMLHttpAd.responseXML; //parse returned xml	
	//alert(responseXml);
		var ads = responseXml.getElementsByTagName("record"); //MIVA
		//var ads = responseXml.getElementsByTagName("Item"); //AMAZON
		var currentAd;
		var adsNum = ads.length; //MIVA
	//alert(adsNum);
		//var adsNum = 2; //AMAZON
		var adTitle;
		var adUrl;
		var adDesc;
		var adImg;
		// if any ads returned
		if  (adsNum > 0)
		{
			velingoSponsoredAdsStr = "<TABLE border=0 cellspacing='0' cellpadding='0' style='margin-top: 8px; " + velingoDefaultFontSize +"'><TR><TD colspan=20%><IMG align=top src=\"" + velngoImageURL + "\"/>&nbsp;</TD><TD nowrap colspan='20%' " + velingoTitleStyle + "><B>Velingo sponsored links:</B>&nbsp;</TD><TD>";
			for (var i=0; i < adsNum; i++)
			{
				currentAd = ads[i];
				adTitle = currentAd.getElementsByTagName("title")[0].firstChild.nodeValue; //MIVA
				//adTitle = currentAd.getElementsByTagName("Title")[0].firstChild.nodeValue; //AMAZON
				adUrl = currentAd.getElementsByTagName("clickurl")[0].firstChild.nodeValue; //MIVA
				//adUrl = currentAd.getElementsByTagName("DetailPageURL")[0].firstChild.nodeValue;
				adDesc = currentAd.getElementsByTagName("description")[0].firstChild.nodeValue; //MIVA
				//adDesc = currentAd.getElementsByTagName("Author")[0].firstChild.nodeValue; //AMAZON
				
		alert(adTitle);		
				adImg = currentAd.getElementsByTagName("mediaurl")[0].firstChild.nodeValue; //MIVA
				velingoSponsoredAdsStr += "<img src=" + adImg +" width=1 height=1 border=0><a " + velingoTagStyle + " href=" + adUrl + " title='" + adDesc + "'>" + adTitle + "</a>&nbsp;&nbsp;"; //MIVA
				//velingoSponsoredAdsStr += "<TD><a " + velingoTagStyle + " href=" + adUrl + " title=\"" + adDesc + "\">" + adTitle + "</a>&nbsp;&nbsp;</TD>"; //AMAZON
				
			}			
			velingoSponsoredAdsStr += "<LABEL " + velingoTagStyle + " id='neverLabel'>never show me ads again</LABEL>";
			velingoSponsoredAdsStr += "</TD></TR></TABLE>";
			// display ads on page
			var adsElement = getDocument().getElementById("ADS_VELINGO");
			adsElement.innerHTML = velingoSponsoredAdsStr;
			
			neverShowVelingoSponsElement = getDocument().getElementById('neverLabel');
			neverShowVelingoSponsElement.addEventListener('click', noSponspredLinks, true);
		}
	}
}

// sends an event to VTS to notify of result hit
function clickResult(url, velingoQuery)
{
	velingoObjXMLHttp = new XMLHttpRequest();
	velingoObjXMLHttp.open("POST", velingoServiceURL, true);
	velingoObjXMLHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
	var requestBody = "event=1&license=" + velingoLicense + "&userAgent=Mozilla/5.0&query=" + velingoQuery + "&url=" + escape(url);
	velingoObjXMLHttp.send(requestBody);
}

// sends an event to VTS to notify of tag hit
function velingoHitTag(tag, url)
{	
	velingoObjXMLHttp = new XMLHttpRequest();
	velingoObjXMLHttp.open("POST", velingoServiceURL, true);
	velingoObjXMLHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
	var requestBody = "event=5&license=" + velingoLicense + "&url=" + url + "&keyword=" + tag.innerHTML;
	velingoObjXMLHttp.send(requestBody);
}

// retrieve a list of related tags for a batch of urls
function getVtsInfo()
{
  	// get up to date language preferences
  	velingoLanguagePrefs = "";
  	if (isDisplayWestEuropeanTags) {
		velingoLanguagePrefs += LANGUAGE_ATTR_PREFIX + "BASIC_LATIN";
	}
	if (isDisplayOtherTags) {
		velingoLanguagePrefs += LANGUAGE_ATTR_PREFIX + "OTHER";
    	}
    	
  	velingoObjXMLHttp = new XMLHttpRequest();
  	velingoObjXMLHttp.onreadystatechange = displayVtsInfo;
	velingoObjXMLHttp.open("POST", velingoServiceURL, true);
	velingoObjXMLHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");	
	var requestBody = "event=9&license=" + velingoLicense + "&query=" + velingoQuery + linksList + "&maxCombinedTags=0&maxWeightedTags=" + tags_per_cloud + velingoLanguagePrefs;
	velingoObjXMLHttp.send(requestBody);	
}

// display document and page tags
function displayVtsInfo()
{
	var doc = getDocument();
	var isVTSOnPage = doc.getElementById("VTS");
	if ((isVTSOnPage == null) && (velingoObjXMLHttp.readyState==4 || velingoObjXMLHttp.readyState=="complete"))
	{
		var responseXml = velingoObjXMLHttp.responseXML;
		embedScript(responseXml, doc);
		displayResultsInfo(responseXml, doc);
		displayBuzzCloud(responseXml, doc);		
	}
}

// embed mandatory scripts on page
function embedScript(responseXml, doc)
{	
	var scriptStr = "<script>var doc = content.document; function clickTag(tag){eval(" + getQueryBox + ").value += \" \" + decodeURI(tag);}</script>";
	
	var dummyElement = doc.getElementById("dummyVTS");
	
	var scriptElement = doc.createElement("div");
	scriptElement.setAttribute("id", "VTS");
	scriptElement.setAttribute("style", velingoBuzzcloudStyle);	
	
	scriptElement.innerHTML = scriptStr;
		
	var insertDiv = eval(getInsertBeforeDivCommand);			
	insertDiv.parentNode.insertBefore(scriptElement, insertDiv);
	
	
	if (isDisplayVelingoSponsoredLinks)
	{
		var velingoAdsElement = doc.createElement("div");
		velingoAdsElement.setAttribute("id", "ADS_VELINGO");
		insertDiv.parentNode.insertBefore(velingoAdsElement, insertDiv);
	}
	
	insertDiv.parentNode.removeChild(dummyElement);
	
	var velingoHeadElement = doc.getElementsByTagName('head')[0];
	velingoHeadElement.innerHTML += velingoEmbededStylesStr;	
}


// display buzz cloud
function displayBuzzCloud(responseXml, doc)
{
	var cloudList = "";
	var cloudTagsArray = responseXml.getElementsByTagName("weighted_tag");

	var cloudTag;
	var cloudTagName;
	var cloudTagWeight;
	var maxWeight = 0;
	var minWeight = 9999;
	var fontSize;
	var cloudTags = '?tags=';
	var len = cloudTagsArray.length;
	var hintdiv = "";
	var adsStr;
	
	if (len > 0)
	{
		<!--  Hint Window -->		
		hintdiv = "<div id=\"hint1\" class=\"hint\"><div id=\"shadow-container\"><div class=\"shadow1\"><div class=\"shadow2\"><div class=\"shadow3\"><div class=\"container\"><table width=\"100%\" height=\"100%\" border=\"0\" style=\"border: solid 1px #748186\" cellspacing=\"0\" cellpadding=\"0\"><tr><td background=\""+ hintImagesDir + "/hint_top.gif\" height=\"11\"></td></tr><tr><td valign=\"top\" style=\"padding: 5px; background-color: white; font-size: 12px; line-height: normal;\"><div id=\"hintContent\" style=\"overflow: auto; width: 98%\"></div></td><tr><td valign=\"bottom\" background=\"" + hintImagesDir + "/hint_bottom.gif\" height=\"14\" align=\"right\" style=\"padding-right: 5px;\"><img src=\"" + hintImagesDir + "/tiny_logo.gif\"></td></tr></table></div></div></div></div></div></div>";
		
		<!--  buzz cloud -->		
		cloudList = "<TABLE id='buzz_cloud_table' border=0 cellspacing='2' cellpadding='2' style='" + velingoBuzzcloudTableStyle + "'>";
				
		cloudList += "<TR><TD style='padding: 5px; line-height:180%; direction: ltr; text-align: left;' width='100%'>";
		
		// go over all tags to determine the maximum/minimum weight
		for (var i = 0 ; i < len; i++)
		{			
			cloudTag = cloudTagsArray[i];
			cloudTagWeight = cloudTag.getAttribute('weight');
			
			if(cloudTagWeight > maxWeight) {
				maxWeight = cloudTagWeight;
			} else if (cloudTagWeight < minWeight) {
				minWeight = cloudTagWeight;
			}
		} 
		
		var distribution = (maxWeight - minWeight) / 4;
		
		// predefined font sizes defined in css
		var minFont = 12;
		var medFont = 15;
		var largeFont = 18;
		var xlargeFont = 22;
		var maxFont = 26;

		for (var i = 0 ; i < len; i++)
		{			
			cloudTag = cloudTagsArray[i];
			cloudTagName = cloudTag.getAttribute('name');
			cloudTagWeight = cloudTag.getAttribute('weight');
			
			// Calculate font-size
			if(cloudTagWeight == minWeight) {
				fontSize = minFont;
			} else if (cloudTagWeight == maxWeight) {
				fontSize = (len > 10) ? maxFont : medFont;
			} else if (cloudTagWeight > (minWeight + distribution*2)) {
				fontSize = medFont;
			} else if (cloudTagWeight > (minWeight + distribution)) {
				fontSize = (len > 10) ? largeFont : medFont;
			} else {
				fontSize = (len > 10) ? xlargeFont : medFont;
			}
					
			cloudList += "<img src='' width=1 height=1 border=0><a href=javascript:void(clickTag('" + encodeURI(cloudTagName) + "')) style='font-size: " + fontSize + "px; text-decoration: none;' onmouseover=\"this.style.textDecoration='underline';this.style.color='red'; this.style.cursor='hand';\" onmouseout=\"this.style.textDecoration='none';this.style.color='#0000CC';\" >" + cloudTagName + "</a>&nbsp;&nbsp;";
							
			cloudTags += cloudTagName + ',';		
		}		
	
		cloudList += "</TD><TD valign=bottom align='right'><a href='http://www.velingo.com' target='_blank'><IMG width='147' height='29' align=bottom border=0 src=\"" + poweredByImageURL + "\"/></a></TD></TR>";
		
		// embed google ads, if any
		if (isDisplayVelingoSponsoredLinks) {
			cloudList += "<IFRAME id='ads_iframe' src='" + getAdsIframeURL + cloudTags + "' frameborder=0 width=100% height=30px style='overflow: hidden;'/>";
		}
		cloudList += "</TABLE>";		
	}
	var vtsElement = doc.getElementById("VTS");
	vtsElement.innerHTML += hintdiv;
	vtsElement.innerHTML += cloudList;
	
	// show hints according to user pref
	if (isShowHintsBuzzCloud) {
		addHintEventListeners(doc);
	}
}

// display tags and relevancy for each search result
function displayResultsInfo(responseXml, doc)
{
	var resultInfoArray = responseXml.getElementsByTagName("result");
	numOfLinks = resultInfoArray.length;
	var resultInfoElement;
	var resultTagsArray;
	var resultTagsNum;
	var tag;
	var socialRelevancy;
	var resultInfoStr;
	var relevancyInfoStr;
	// traverse results in page
	for (var i = 0; i < numOfLinks; i++)
	{
		relevancyInfoStr = null;
		resultInfoElement = resultInfoArray[i];		
		if (resultInfoElement.getAttribute('total') != '0')		
		{			
			resultInfoStr = "<TABLE border=0 cellpadding=0 cellspacing=0 style='" + velingoDefaultFontSize + "'>";
			
			// get document tags
			resultTagsArray = resultInfoElement.getElementsByTagName("tag");
			resultTagsNum = resultTagsArray.length;
			if ((sponsoredRegArray[i] == undefined) && (sponsoredSideArray[i] == undefined)) // regular result, show relevancy and tags
			{
				resultInfoStr += "<TR style='padding-top: 3px;'><TD " + velingoTitleStyle + "><B>Velingo Tags:</B>&nbsp;&nbsp;</TD><TD style='direction: rtl; text-align: left;'>";
				// traverse document tags, build document tags string	
				for (var j = 0; j < resultTagsNum; j++)
				{
					tag = resultTagsArray[j].getAttribute('name');
					resultInfoStr +=  "<a href=javascript:void(clickTag('" + encodeURI(tag) + "')) " + velingoTagStyle + ">" + tag + "</a>"  + velingoSeperator;
				}
				// remove last |
				resultInfoStr = resultInfoStr.substring(0, resultInfoStr.length - velingoSeperator.length);
				resultInfoStr +=  "</TD>";	
				relevancyInfoStr = addSocialRelevancy(resultInfoElement);
				resultInfoStr += "</TR></TABLE>";	
			} 
			else if (sponsoredRegArray[i] != undefined) // sponsored link, show tags
			{
				resultInfoStr += "<TR><TD><B>Velingo Tags:</B>&nbsp;&nbsp;";
				// traverse document tags, build document tags string
				for (var j = 0; j < resultTagsNum; j++)
				{
					tag = resultTagsArray[j].getAttribute('name');
					resultInfoStr +=  "<a href=javascript:void(clickTag('" + encodeURI(tag) + "')) " + velingoTagStyle + ">" + tag + "</a>"  + velingoSeperator;
				}
				// remove last |
				resultInfoStr = resultInfoStr.substring(0, resultInfoStr.length - velingoSeperator.length);
				resultInfoStr +=  "</TD></TR></TABLE>";
			} 
			else if (sponsoredSideArray[i] != undefined) // sponsored side link, show few tags
			{
				resultInfoStr += "<TR width='100%'><TD " + velingoTitleStyle +"><B>Velingo Tags:</B>&nbsp;</TD>";
				// traverse document tags, build document tags string
				for (var j = 0; ((j<sponsoredTagsSmallNum) && (j<resultTagsNum)); j++)
				{
					tag = resultTagsArray[j].getAttribute('name');
					resultInfoStr +=  "<TD style='padding-left: 6px'><a href=javascript:void(clickTag('" + encodeURI(tag) + "')) " + velingoTagStyle + ">" + tag + "</a></TD>";
				}
				resultInfoStr +=  "</TR></TABLE>";
			}
			// embed tags in page
			var tagsElement = doc.createElement("div");
			tagsElement.setAttribute("id", "docTags");
			tagsElement.setAttribute("style", "margin-top:0em; valign:top;");
			tagsElement.innerHTML = resultInfoStr;
			appendDocInfoNodeArray[i].appendChild(tagsElement);
	
			// embed relevancy info in page
			if (relevancyInfoStr != null)
			{
				var relevancyElement = doc.createElement("span");
				relevancyElement.setAttribute("id", "docRelevancy");
				relevancyElement.innerHTML = relevancyInfoStr;
				appendDocRelevancyNodeArray[i].appendChild(relevancyElement);
			}
		}		
	}
}

// Retruns a result's social relevancy bar and value
function addSocialRelevancy(resultInfoElement)
{
	var socialRelevancyStr = "";
	var helper = resultInfoElement.getElementsByTagName("social_relevancy")[0];
	// add social relevancy
	if (helper != null) {
		var socialRelevancy = helper.getAttribute('value');
		if (socialRelevancy != '0.0')
		{
			socialRelevancyStr = "<TABLE cellspacing='0' cellpadding='0' style='" + velingoDefaultFontSize + "'><TR><TD " + velingoTitleStyle + ">Velingo Social Relevancy:&nbsp;</TD>";  //title
			socialRelevancyStr += "<TD style='padding-top: 3px;'><table border=1 bordercolor=black cellpadding=0 cellspacing=0 align='left' valign='middle'>";			
			try
			{
				socialRelevancy = socialRelevancy.substring(0, 2);
			}
			catch(err)
			{
			}
			socialRelevancyStr += "<TR>";
			socialRelevancyStr += "<TD valign='middle' bgcolor='#60BF60' width='"+ socialRelevancy + "' height=6 border=0></TD>"; //green bar
			socialRelevancyStr += "<TD valign='middle' bgcolor='white' width='" + (100 - socialRelevancy) + "' height=6 border=0></TD>"; // white bar
			socialRelevancyStr += "</TR></TABLE>";	// end bar
			socialRelevancyStr += "<TD " + velingoTitleStyle + ">&nbsp;&nbsp;" + socialRelevancy + "%</TD></TD></TABLE>";
		}
	}
	return socialRelevancyStr;
}

// get the current engine's variables from the xml
function getEngineVariables(velingoPageTitle)
{
	getQueryCommand = null;
	
	// perform only once
	var parser = new DOMParser();
	velingoXmlDoc = parser.parseFromString(variablesData, "text/xml");
	var engines = velingoXmlDoc.getElementsByTagName('engine');
	var enginesNum = engines.length;
	var engine;
	var titles;
	var titlesNum;
	var curTitle;
	var noEngineRecognized = true;
	for (var i = 0; noEngineRecognized && i < enginesNum; i++) 
	{
		engine = engines[i];
		titles = engine.getElementsByTagName('title');
		titlesNum = titles.length;
		for (var j = 0; j < titlesNum; j++)
		{
			curTitle = decodeURI(titles[j].getAttribute('value'));
			if (velingoPageTitle.indexOf(curTitle) > -1)
			{
				// read search engines variables
				VelingoSearchEngineName = engine.getAttribute('name');			
				getQueryBox = engine.getElementsByTagName('getQueryBox')[0].firstChild.nodeValue;
				getQueryCommand = engine.getElementsByTagName('getQueryCommand')[0].firstChild.nodeValue;
				resultElementTagName = engine.getElementsByTagName('resultElementTagName')[0].firstChild.nodeValue;
				isLinkResultCheckCommand = engine.getElementsByTagName('isLinkResultCheckCommand')[0].firstChild.nodeValue;

				isLinkSponsoredRegCheckCommand = engine.getElementsByTagName('isLinkSponsoredRegCheckCommand')[0].firstChild.nodeValue;
				isLinkSponsoredSideCheckCommand = engine.getElementsByTagName('isLinkSponsoredSideCheckCommand')[0].firstChild.nodeValue;
				getSponsoredRegLinkCommand = engine.getElementsByTagName('getSponsoredRegLinkCommand')[0].firstChild.nodeValue;
				getSponsoredSideLinkCommand = engine.getElementsByTagName('getSponsoredSideLinkCommand')[0].firstChild.nodeValue;			
				getAppendRegSponsoredTagsNodeCommand = engine.getElementsByTagName('getAppendRegSponsoredTagsNodeCommand')[0].firstChild.nodeValue;
				getAppendSideSponsoredTagsNodeCommand = engine.getElementsByTagName('getAppendSideSponsoredTagsNodeCommand')[0].firstChild.nodeValue;

				getLinkCommand = engine.getElementsByTagName('getLinkCommand')[0].firstChild.nodeValue;
				getInsertBeforeDivCommand = engine.getElementsByTagName('getInsertBeforeDivCommand')[0].firstChild.nodeValue;
				getAppendDocRelevancyNodeCommand = engine.getElementsByTagName('getAppendDocRelevancyNodeCommand')[0].firstChild.nodeValue;
				getAppendDocInfoNodeCommand = engine.getElementsByTagName('getAppendDocInfoNodeCommand')[0].firstChild.nodeValue;

				velingoTitleStyle = engine.getElementsByTagName('titleStyle')[0].firstChild.nodeValue;
				velingoTagStyle = engine.getElementsByTagName('tagStyle')[0].firstChild.nodeValue;
				velingoDefaultFontSize = engine.getElementsByTagName('defaultFontSize')[0].firstChild.nodeValue;
				velingoBuzzcloudStyle = engine.getElementsByTagName('buzzcloudStyle')[0].firstChild.nodeValue;
				velingoBuzzcloudTableStyle = engine.getElementsByTagName('buzzcloudTableStyle')[0].firstChild.nodeValue;				

				noEngineRecognized = false;
				break;
			}
		}
	}
}

// request an asynchronous update for vars.xml file from the server, every 1 hour
function requestXmlFile()
{
	var currentTime = (new Date()).getTime();  // current time in millis
	// it's time to update the file
	if (currentTime - velingoXmlFile.lastModifiedTime > updateFileGapMillis || velingoXmlFile.fileSize == 0)
	{
		// call service to get the content of the xml file and write it to disk
		getVarsFile();
	}
}

// get the content of vars.xml 
function getVarsFile()
{	
  	// send request to server
  	velingoObjXMLHttpForFile = new XMLHttpRequest();
  	velingoObjXMLHttpForFile.onreadystatechange = writeFile;
	velingoObjXMLHttpForFile.open("POST", getFileServiceURL, true);
	velingoObjXMLHttpForFile.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
	var requestBody = "version=" + vars_xml_version;	
	velingoObjXMLHttpForFile.send(requestBody);
}

// writes content returned from the server to the local file
function writeFile()
{
	if (velingoObjXMLHttpForFile.readyState==4 && velingoObjXMLHttpForFile.status==200)
	{
		var responseXml = velingoObjXMLHttpForFile.responseText;
		// if file version is unchanged - empty return text, else - the new xml
		if (responseXml.length > 10) //file was changed
		{
			// update variable
			variablesData = responseXml;
			// update file
			xpcomFileWrite(responseXml); 
		}
	}
	// update version
	vars_xml_version = getVarsFileVersion(variablesData);
}

// write content to local vars.xml file
function xpcomFileWrite(content) 
{
	try 
	{
		// Write to file with nsIFileOutputStream
		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		
		outputStream.init(velingoXmlFile, 0x04 | 0x20, 0666, 0);
		outputStream.write(content, content.length);
		outputStream.flush();
		outputStream.close();
	} catch(e) 
	{
		alert("Exception when writing file: " + e);
	}
}

// write last search to history file, supports UTF
function writeHistory(velingoQuery)
{
	if (velingoQuery != null && velingoQuery != '')
	{	
		var writeBack = "";
		if (velngoHistoryRecordsLimit > 0)
		{
			// open an input stream from file, read current history file into a string, with UTF-8 support
			var fis = Components.classes["@mozilla.org/network/file-input-stream;1"]
						.createInstance(Components.interfaces.nsIFileInputStream);
			fis.init(velngoHistoryFile, 0x01, 0444, 0);
			fis.QueryInterface(Components.interfaces.nsILineInputStream);

			// open an input stream that supports UTF-8
			const replacementChar = Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;
			var istream = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
				   .createInstance(Components.interfaces.nsIConverterInputStream);
			istream.init(fis, velingoCharset, 1024, replacementChar);

			// last query written first
			writeBack = velingoQuery + history_record_seperator + (new Date()).getTime();   // query and the search time in millis
			var line = {}, linesNum = 1;
			var fileHasMoreLines;
			var fileSize = velngoHistoryFile.fileSize;
			// read lines
			if (fileSize > 0 && velngoHistoryRecordsLimit > 1 && istream instanceof Components.interfaces.nsIUnicharLineInputStream)
			{
				do 
				{
					fileHasMoreLines = istream.readLine(line);
					writeBack += "\n" + line.value;
					linesNum++;

				} while(fileHasMoreLines && linesNum < velngoHistoryRecordsLimit);


			}
			istream.close();
			fis.close();
		}	
		// write records back to file
		// file output stream
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
						 .createInstance(Components.interfaces.nsIFileOutputStream);

		foStream.init(velngoHistoryFile, 0x04 | 0x20, 0666, 0);  // 0x04 for read&write, 0x20 for deleting existing content, 0666 to read and write by everybody
		

		// internationalize output stream
		var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
				   .createInstance(Components.interfaces.nsIConverterOutputStream);

		// This assumes that fos is the nsIOutputStream you want to write to
		os.init(foStream, velingoCharset, 0, 0x0000);
		os.writeString(writeBack);
		os.close();
		foStream.close();
	}	
}


// displays the search history - temp to be changed after we decide on UI
// TODO:  add grouping by date, currently not called from anywhere
function displayHistory()
{
	// open an input stream from file
	var fis = Components.classes["@mozilla.org/network/file-input-stream;1"]
	                        .createInstance(Components.interfaces.nsIFileInputStream);
	fis.init(velngoHistoryFile, 0x01, 0444, 0);
	fis.QueryInterface(Components.interfaces.nsILineInputStream);
	
	// open an input stream that supports UTF-8
	const replacementChar = Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;
	var istream = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
                   .createInstance(Components.interfaces.nsIConverterInputStream);
	istream.init(fis, velingoCharset, 1024, replacementChar);

	var historyStr='';
	var line = {};
	var fileHasMoreLines;
	var fileSize = velngoHistoryFile.fileSize;
			
	if (fileSize > 0 && istream instanceof Components.interfaces.nsIUnicharLineInputStream)
	{
		do 
		{
			fileHasMoreLines = istream.readLine(line);
			historyStr += line.value + "\n";
		
		} while(fileHasMoreLines);
		
		alert(historyStr);		
	}
	istream.close();
	fis.close();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

window.addEventListener("pageshow", function() { velingotags.onLoad(); }, false);

velingotags.registerPrefListener();

initHostServer();

initPrefVars();

initVarsFile();

readFiles();

initHistoryFile();

//displayHistory();

getLocalIp();

/////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

// progress listener for web page address change 
var myExt_urlBarListener = {
  QueryInterface: function(aIID)
  {
   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
     return this;
   throw Components.results.NS_NOINTERFACE;
  },

  onLocationChange: function(aProgress, aRequest, aURI)
  {
    velingotags.onChange();
  },

  onStateChange: function() {},
  onProgressChange: function() {},
  onStatusChange: function() {},
  onSecurityChange: function() {},
  onLinkIconAvailable: function() {}
};


function initHostServer()
{
	var agent = navigator.userAgent;
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		
	if (agent.indexOf('Windows') > -1) //windows
	{	
		myVarsFilePath = velingoPrefs.getCharPref("myVarsFilePathWindows");
		velngoHistoryFilePath = velingoPrefs.getCharPref("history_file_location_windows");
		velingoEmbedStylesFilePath = velingoPrefs.getCharPref("embedStylesFilePathWindows");
		
	}
	else  // linux
	{
		myVarsFilePath = velingoPrefs.getCharPref("myVarsFilePathLinux");
		velngoHistoryFilePath = velingoPrefs.getCharPref("history_file_location_linux");
		velingoEmbedStylesFilePath = velingoPrefs.getCharPref("embedStylesFilePathLinux");
	}
	velingo_host_server = velingoPrefs.getCharPref("hosted_host_server");
	
}

// Gets a reference to a file object, called once when this js is loaded
function initVarsFile()
{

	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

	// Get file component.
	velingoXmlFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	// get path to our extension's folder
	ext = Components.classes["@mozilla.org/extensions/manager;1"]
			      .getService(Components.interfaces.nsIExtensionManager)
			      .getInstallLocation(velingoId)
			      .getItemLocation(velingoId);
	
	myVarsFilePath = ext.path + myVarsFilePath;
	velingoXmlFile.initWithPath(myVarsFilePath);

	try { // create the file, only on first time
		velingoXmlFile.create(velingoXmlFile.NORMAL_FILE_TYPE, 0666);
	} catch (e) {	
	}
	
	readVariablesXML(myVarsFilePath);
}

// read xml file to get local variable values
function readVariablesXML(filePath)
{
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(filePath);
	variablesData = "";
	var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
				.createInstance(Components.interfaces.nsIFileInputStream);
	var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
				.createInstance(Components.interfaces.nsIScriptableInputStream);
	fstream.init(file, 0x01, 0444, 0);
	sstream.init(fstream);

	var str = sstream.read(4096);
	while (str.length > 0) 
	{
	  variablesData += str;
	  str = sstream.read(4096);
	}	
	sstream.close();
	fstream.close();

	// get file version
	vars_xml_version = getVarsFileVersion(variablesData);	

}

//returns version from xml
function getVarsFileVersion(xmlText)
{
	var parser = new DOMParser();
	var velingoXmlDoc = parser.parseFromString(xmlText, "text/xml");
	var versions = velingoXmlDoc.getElementsByTagName('version');	
	return (versions[0].getAttribute('value'));
}

// initialize preference variables, called once, updated on user-change
function initPrefVars()
{
	velingoServiceURL = velingo_host_server + velingoPrefs.getCharPref("serviceURL");
	getFileServiceURL = velingo_host_server + velingoPrefs.getCharPref("getFileServiceURL");
	velngoImageURL = velingo_host_server + velingoPrefs.getCharPref("imageURL");
	poweredByImageURL = velingo_host_server + velingoPrefs.getCharPref("poweredByImageURL");
	velingoHintURL = velingoPrefs.getCharPref("hintURL");
	
	isDisplaySponsoredLinksTags = velingoPrefs.getBoolPref("show_sponsored_links_tags");
	isDisplayVelingoSponsoredLinks = velingoPrefs.getBoolPref("show_velingo_sponsored_links");
	tags_per_cloud = velingoPrefs.getIntPref("tags_per_cloud");	
	velngoHistoryRecordsLimit = velingoPrefs.getIntPref("num_of_history_records");
	velingoSponsoredServiceUrl = velingoPrefs.getCharPref("velingo_sponsored_service_url");
	
	isDisplayWestEuropeanTags = velingoPrefs.getBoolPref("lang_western_european");
	isDisplayOtherTags = velingoPrefs.getBoolPref("lang_other");

	getAdsIframeURL = velingo_host_server + velingoPrefs.getCharPref("getAdsIframeURL");
	
	isShowHintsBuzzCloud = velingoPrefs.getBoolPref("show_hints_buzzcloud");			
	hintImagesDir = velingoPrefs.getCharPref("hintImagesDir");

}

// initialize history file reference
function initHistoryFile()
{
	//get history file (included in xpi)
	velngoHistoryFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);			
	velngoHistoryFilePath = ext.path + velngoHistoryFilePath;
	velngoHistoryFile.initWithPath(velngoHistoryFilePath);
	try { // create the file, only on first time
		velngoHistoryFile.create(velngoHistoryFile.NORMAL_FILE_TYPE, 0666);
	} catch (e) {	
	}
	// TODO:  delete file before publishing
}

// setup ipv6_localip with all local ips
function getLocalIp() 
{
	if (velingoLocalip)
	{
		return velingoLocalip;
	}
	// register dns class 
	var cls = Components.classes['@mozilla.org/network/dns-service;1'];
	var iface = Components.interfaces.nsIDNSService;
	var dns = cls.getService(iface);
	var a = new Array();
	// doc.location is the Location object
	try {
		var nsrecord = dns.resolve(dns.myHostName, true);
		while (nsrecord.hasMore()) {
			a[a.length] = nsrecord.getNextAddrAsString();
		}
	} catch (e) { }
	velingoLocalip = a.join(" | ");
	return this.velingoLocalip;
}

// trim string
function trim(stringToTrim) 
{
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

// returns the doc object, different for ie / ff
function getDocument()
{
	if (navigator.userAgent.indexOf("Firefox") > -1)
	{
		return content.document; // mozilla
	} else {
		return document; // ie
	}
}

// set preference to not show velingo sponsored links
function noSponspredLinks() 
{
	velingoPrefs.setBoolPref("show_velingo_sponsored_links", false);
	isDisplayVelingoSponsoredLinks = false;
}

// loads to memory additional files
function readFiles() 
{	
	// read styles txt
	velingoEmbededStylesStr =  readFile(velingoEmbedStylesFilePath);
}

// read js file to get hints related functions, which will be embedded in page
function readFile(file_path)
{
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

	// Get file component.
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	// get path to our extension's folder
	ext = Components.classes["@mozilla.org/extensions/manager;1"]
			      .getService(Components.interfaces.nsIExtensionManager)
			      .getInstallLocation(velingoId)
			      .getItemLocation(velingoId);
	
	file_path = ext.path + file_path;
	
	file.initWithPath(file_path);

	var fileContent = "";
	var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
				.createInstance(Components.interfaces.nsIFileInputStream);
	var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
				.createInstance(Components.interfaces.nsIScriptableInputStream);
	
	fstream.init(file, 0x01, 0444, 0);
	sstream.init(fstream);
	var str = sstream.read(4096);
	while (str.length > 0) 
	{
	  fileContent += str;
	  str = sstream.read(4096);
	}	
	sstream.close();
	fstream.close();
	return fileContent;
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

// Hint functions
function addHintEventListeners(doc)
{	
	
	// event listeners to hint div
	var hintDiv = doc.getElementById("hint1");
	hintDiv.addEventListener("mouseover", function() { velingo_overHint=true; cancelHidingHint(); } , true);
	hintDiv.addEventListener("mouseout", function() { velingo_overHint=false; } , true);
		
	// add event listeners to all buzzcloud tags
	var tags = doc.getElementById("buzz_cloud_table").getElementsByTagName("A");	
	var numOfTags = tags.length;
	for (var i = 0 ; i < numOfTags ; i++)
	{
		tags[i].addEventListener("mouseover", function() { beginHintRequest(this); } , true);
		tags[i].addEventListener("mouseout", function() { velingo_overTag=false; } , true);		
		tags[i].addEventListener("click", function() { velingoHitTag(this, 'extension_buzz_cloud ('  + VelingoSearchEngineName + ")"); } , true);		
	}	
}

	
// show hints when hovering over a tag in the buzzcloud
// Show the Hint

function showHint() {
	var doc = getDocument();
	var ui = doc.getElementById("hint1");
	var hintContent = doc.getElementById("hintContent");
	var p = velingo_response.indexOf("\n");
	var disambig = velingo_response.substring(0, p) == "true";
	var content = velingo_response.substring(p+1);
	var html;
	var tagFontSize;

	var tagsTable = doc.getElementById("buzz_cloud_table");

	if (!velingo_overTag) {
		return; // The user has moved away from the tag, don't show the hint
	}

	// Set the velingo_overHint flag to false because we're not over the hint (obviously) and cancel
	// any pending hint hiding
	velingo_overHint = false;		
	cancelHidingHint();	

	// Hiding the hint by moving over the BODY is delayed by setting this timeout 
	doc.body.removeEventListener("mouseover", beginHideHint, true);

	setTimeout("setBodyListener()", DELAY_HIDING_BY_BODY);					

	// If there's no content, return
	if (content == "null") {
		return; 
	}

	// For disambiguations, create a UL tag, for definitions, use the content as is.
	if (disambig) {		
		lines = content.split("\\n");

		html = "<ul style='margin-left: 5px; margin-top: 5px; padding-left: 15px; list-style-type: square'>";

		for (i = 0; i < Math.min(lines.length, 5); i++) {
			if (lines[i] != "") html += "<li>" + lines[i] + "</li>";
		}

		html += "</ul>";

	} else {
		html = content.replace("\\n", "<br>");
	}				

	// Reset the hint box's height	
	hintContent.style.height = "";	

	// Set the hint box's innerHTML, top and left		
	hintContent.innerHTML = html;


	tagFontSize = parseInt(velingo_hintTarget.style.fontSize.substring(0, velingo_hintTarget.style.fontSize.length - 2));

	ui.style.top = velingoHintTop + tagsTable.offsetTop + tagFontSize + 10 + "px";		
	ui.style.left = velingoHintLeft + tagsTable.offsetLeft + 2 + "px";

	if (content.length > 0) {																	
		// Set a maximum height for the hint box. Anything before is scrolled
		if (hintContent.clientHeight > 120) {												
			hintContent.style.height = "135px";				
		}						

		ui.style.visibility = "visible";
		velingo_h_hideHint = 0; // Reset the hiding handle
	}
	else hideHint();
}

// Enable hint hiding by moving over the BODY 
function setBodyListener() {	
	getDocument().body.addEventListener("mouseover", beginHideHint, true);
}

// Hides the hint
function hideHint() {		
	var ui = getDocument().getElementById("hint1");		
	if (!velingo_overHint)
		ui.style.visibility = "hidden";
}

// Begin hiding by setting a timer
function beginHideHint() {

	velingo_overTag=false;
	var ui = getDocument().getElementById("hint1");								

	if (ui.style.visibility == "visible" && velingo_h_hideHint == 0) {			
		velingo_h_hideHint = setTimeout("hideHint()", VELINGO_HIDE_HINT_DELAY);			
	}
}

// Cancel a pending hiding
function cancelHidingHint() {								
	clearTimeout(velingo_h_hideHint);		
	velingo_h_hideHint = 0;		
}		

// Start a request for a new hint
function beginHintRequest(e) {

	velingoHintLeft = e.offsetLeft;
	velingoHintTop = e.offsetTop;

	velingo_overTag=true;

	velingo_hintTarget = e;

	// Set the velingo_showDelayFlag to false and then set it to true after VELINGO_SHOW_HINT_DELAY ms.
	hideHint();
	velingo_showDelayFlag = false;	
	setTimeout("setDelayFlag()", VELINGO_SHOW_HINT_DELAY);			

	// Ajax call	
	velingo_objSL = new XMLHttpRequest();

	velingo_objSL.onreadystatechange = requestHintCallback;

	velingo_objSL.open("GET", velingoHintURL + "?keyword=" + escape(e.innerHTML), true);

	velingo_objSL.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
	velingo_objSL.send(null);
}

// This function is called after VELINGO_SHOW_HINT_DELAY ms. and sets the velingo_showDelayFlag to true
function setDelayFlag() {
	velingo_showDelayFlag = true;
}

// This function is called every VELINGO_SHOW_DELAY_CHECK_INTERVAL and waits for the velingo_showDelayFlag to become true
function checkDelayFlag() {	
	if (velingo_showDelayFlag) {
		showHint();
	}
	else {
		// Async. recursive call every VELINGO_SHOW_DELAY_CHECK_INTERVAL ms.
		setTimeout("checkDelayFlag()", VELINGO_SHOW_DELAY_CHECK_INTERVAL);
	}	
}

// Ajax Callback
function requestHintCallback()
{
	if (velingo_objSL.readyState==4 || velingo_objSL.readyState=="complete")
	{
		try 
		{							
			velingo_response = velingo_objSL.responseText;
			checkDelayFlag();				
		}
		catch (e) 
		{
		}			
	}
}